#!perl -w
# in above -w turns on some warnings

# all statements that start with # are comments

# perl script to back up the cloudy source files onto a different computer
# this is automatically executed once per week, early Saturday morning

# bring in the perl module that includes copy
use File::Copy;

#	nt
# the disk drive where the files and results live, we will back this up
$c = "c";
# input and output directories
#$in_dir = "$f:/projects/cloudy/tsuite/short/";
#$out_dir = "$f:/projects/cloudy/tsuite/short/";
$in_dir = "$c:/projects/cloudy/current/tsuite/auto/";
$out_dir = "g:/backup/cloudy/";
$cdrw_dir = "j:/";

# get current time and date
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
                                            gmtime(time);
# create basename for file
$basename = "$year"."$mon"."$mday" ;

# move to the directory, which contains source.tar and 
if( !chdir( $in_dir ) )
{
	printf(" invalid directory for output of test suite\n");
	printf(" was ==%s==\n",$in_dir );
	exit(1);
}
# finally copy exe file here
$exe = "$out_dir"."$basename".".exe" ;
$tar = "$out_dir"."$basename".".tar";
$dat = "$out_dir"."$basename".".data.tar";
copy( "cloudy.exe" , $exe );
copy( "source.tar" , $tar );
copy( "data.tar"   , $dat );
# move to the directory, which contains source.tar and 
if( !chdir( $out_dir ) )
{
	printf(" invalid directory for output of test suite\n");
	printf(" was ==%s==\n",$out_dir );
	exit(1);
}
# have to delete existing files since gzip will hang waiting for response on overwrite
if( -e "$exe".".gz" )
{
	unlink( "$exe".".gz" );
}
if( -e "$tar".".gz" )
{
	unlink( "$tar".".gz" );
}
if( -e "$dat".".gz" )
{
	unlink( "$dat".".gz" );
}

system( "gzip $exe" );
system( "gzip $tar" );
system( "gzip $dat" );

# copy it to the cdrw 

copy( "$exe.gz" , $cdrw_dir );
copy( "$tar.gz" , $cdrw_dir );
copy( "$dat.gz" , $cdrw_dir );

send_mail();
exit;


#=============================================================
#             send_mail(),
#=============================================================

sub send_mail {
 
	use OLE;

	$DevMailer = CreateObject OLE 'Geocel.Mailer';
	$DevMailer->AddServer ("cloud9.pa.uky.edu",25);
	$DevMailer->AddRecipient ("gary\@cloud9.pa.uky.edu","Gary Ferland");
	$DevMailer->{FromName}  = "Cloudy backup";
	$DevMailer->{FromAddress}  = "gary\@cloud9.pa.uky.edu";

	$DevMailer->{Subject} = "exe and source backed up to nimbus";  
	$DevMailer->{Body} = "file name was ";
	$DevMailer->{Body} = $DevMailer->{Body} . $basename;
	# actually send the email
	$success = $DevMailer->Send();
 
}
